# -*- coding: utf-8 -*-
##############################################################################
# SUDOKEYS:2014
# sudokeys_bluemind_connector
# Author:YL
# created:01-2014
#
#
#
#
##############################################################################

from tools.translate import _
from osv import osv,orm, fields
from suds.client import Client
from suds import WebFault
import threading
from datetime import datetime
from openerp import pooler, sql_db
from openerp.addons import product
import logging
_logger = logging.getLogger(__name__)    
logging.basicConfig(level=logging.INFO)
if __debug__:
    logging.getLogger('suds.client').setLevel(logging.DEBUG)
else:
    logging.getLogger('suds.client').setLevel(logging.CRITICAL)

class bluemind_config(osv.osv):
    _name = 'bluemind.config'
    _columns = {
            'wsdl_url': fields.char(u'WSDL URL', size=255, required=True),    
            'user':fields.char(u'User', size=64, required=True),
         #   'password':fields.char(u'Password', size=64, required=True),
            'domain': fields.char(u'Domain name',required=True),
            'domain_admin': fields.char('Domain administrator',required=True),
            'api_key':fields.char(u'API Key', size=255, required=True),
            'folder_id':fields.integer(u'Address book', required=True),
            'contact_last_sync': fields.datetime('Contact date synchronization from Bluemind', required=True),
            }   
    _defaults = {
            'contact_last_sync':lambda self, cr, uid, ctx: datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
            } 
    def get_client(self, cr, uid, config_data):
        try:
            client = Client(config_data['wsdl_url'])
            return client
        except WebFault, f:
            _logger.debug(f)
            _logger.debug(f.fault)
            raise osv.except_osv('Error',_("Please check WSDL url !"))
        except Exception, e:
            _logger.debug(e)
            raise osv.except_osv('Error',_("Please check WSDL url !"))
        return False
    
    def get_accessToken(self, cr, uid, config_data):
        try:
            client = Client(config_data['wsdl_url'])
            accessToken = client.service.login(config_data['user'], config_data['api_key'], config_data['api_key'])
            return accessToken
        except WebFault, f:
            _logger.debug(f)
            _logger.debug(f.fault)
            raise osv.except_osv('Error',_('Failure Connexion to web service Bluemind !'))
        except Exception, e:
            _logger.debug(e)
            raise osv.except_osv('Error',_('Failure Connexion to web service Bluemind !'))
        return False
    
    def get_config_data(self, cr, uid):
        blmind_cf_ids = self.search(cr, uid,[])
        if len(blmind_cf_ids)>=1:
            data = self.read(cr, uid, blmind_cf_ids, [])[0]
            return data
        else:
            raise osv.except_osv('Warning',_('The OpenERP Bluemind connector is not configured yet !'))
            return False
            
bluemind_config()

class calendar_config(osv.osv):
    _name = 'calendar.config'
    _columns = {
            'event_last_sync': fields.datetime('Contact date synchronization from Bluemind', required=True),
            }
    
    _defaults = {
            'event_last_sync':lambda self, cr, uid, ctx: datetime.now().strftime('%Y-%m-%d %H:%M:%S')
            } 
    
calendar_config() 

class bluemind_connection(osv.osv_memory):
    _name = 'bluemind.connection'
    
    def _is_already_config(self, cr, uid, context=None):
        bluemind_cf_ids = self.pool.get('bluemind.config').search(cr, uid, [])
        if not bluemind_cf_ids:
            return False
        return bluemind_cf_ids
    
    def _get_blmind_config(self, cr, uid, context=None):
        bluemind_cf_ids = self._is_already_config(cr, uid, context)
        if bluemind_cf_ids:
            data = self.pool.get('bluemind.config').read(cr, uid, bluemind_cf_ids,[])[0]
            return data
        return False
    
    def _get_wsdl_url(self, cr, uid, context=None):
        res = ''
        blmind_config = self._get_blmind_config(cr, uid, context)
        if blmind_config:
            res = blmind_config['wsdl_url']
        return res
    
    def _get_user(self, cr, uid, context=None):
        res = ''
        blmind_config = self._get_blmind_config(cr, uid, context)
        if blmind_config:
            res = blmind_config['user']
        return res
    
#    def _get_password(self, cr, uid, context=None):
#        res = ''
#        blmind_config = self._get_blmind_config(cr, uid, context)
#        if blmind_config:
#            res = blmind_config['password']
#        return res
    
    def _get_api_key(self, cr, uid, context=None):
        res = ''
        blmind_config = self._get_blmind_config(cr, uid, context)
        if blmind_config:
            res = blmind_config['api_key']
        return res
    
    def _get_domain(self, cr, uid, context=None):
        res = ''
        blmind_config = self._get_blmind_config(cr, uid, context)
        if blmind_config:
            res = blmind_config['domain']
        return res
    def _get_domain_admin(self, cr, uid, context=None):
        res = ''
        blmind_config = self._get_blmind_config(cr, uid, context)
        if blmind_config:
            res = blmind_config['domain_admin']
        return res
    
    _columns = {
            'wsdl_url': fields.char(u'WSDL URL', size=255, required=True),    
            'user':fields.char(u'User', size=64, required=True),
          #  'password':fields.char(u'Password', size=64, required=True),
            'domain': fields.char(u'Domain name',required=True),
            'domain_admin': fields.char('Domain administrator name',required=True),
            'api_key':fields.char(u'API Key', size=255, required=True),
            'is_connect': fields.selection([('yes','yes'),('no','no'),('default','default')], u"Connected ?")
            }
    
    _defaults = {
            'wsdl_url': _get_wsdl_url,
            'user':_get_user,
#            'password':_get_password,
            'api_key':_get_api_key,
            'domain':_get_domain,
            'domain_admin':_get_domain_admin,
            'is_connect':lambda self, cr, uid, context: context['is_connect'],
            }
    
    def connect(self, cr, uid, ids, context=None):
        data = self.browse(cr, uid, ids)[0]
        is_connect = 'default'
        try:
            client = Client(data['wsdl_url'])
            access_token = dict(client.service.login(data['user'], data['api_key'], data['api_key']))
            if access_token.get('sessionId',False):
                is_connect = 'yes'
                self._create_config_data(cr, uid, ids, client, access_token, context)
            else:
                is_connect = 'no'
        except WebFault, f:
            is_connect = 'no'
            _logger.debug(f)
            _logger.debug(f.fault)
        except Exception, e:
            is_connect = 'no'
            _logger.debug(e)
            
        return {
            'name':'Bluemind connection',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'bluemind.connection',
            'type': 'ir.actions.act_window',
            'nodestroy': True,
            'target': 'new',
            'context':{'is_connect':is_connect},
            'res_id': False,
        }
       
    def _create_config_data(self, cr, uid, ids, client, access_token, context=None):
        vals = self.read(cr, uid, ids, [], context=context)[0]
        if 'is_connect' in vals:
            del vals['is_connect']  
        if 'id' in vals:
            del vals['id']
        if '@' not in vals['domain_admin']:
            vals['domain_admin'] = vals['domain_admin']+'@'+vals['domain']
        try:
            access_token = client.service.sudo(access_token,vals['domain_admin'])
        except WebFault, f:
            _logger.debug(f)
            _logger.debug(f.fault)
            raise osv.except_osv('Connection Error',f)
        except Exception, e:
            print e
            _logger.debug(e)
            raise osv.except_osv('Error',e)
        folder_id = self._create_contact_folder(cr, uid, client, access_token)
        if folder_id:
            vals['folder_id'] = folder_id
        else:
            raise osv.except_osv(_('Error'),_("Can't create an address book in Bluemind!"))
        blmind_cf = self.pool.get('bluemind.config')
        bluemind_cf_ids = self._is_already_config(cr, uid, context)
        if not bluemind_cf_ids:
            blmind_cf.create(cr, uid, vals, context=context)
        else:
            blmind_cf.unlink(cr, uid, bluemind_cf_ids, context=context)
            blmind_cf.create(cr, uid, vals, context=context)
        self._create_last_sync(cr, uid)
        return True
    
    def _create_contact_folder(self, cr, uid, client, access_token):
        folder_id = False
        try:
            folderQuery = client.factory.create('folderQuery')
            folderQuery.name = 'OpenERP Partners'
            folders = client.service.findFolders(access_token,folderQuery)
            if len(folders)>0:
               folder_id =  folders[0].id
               client.service.subscribreMassUserFromAFolder(access_token, folder_id, [access_token['userId']])  
            else:
                folder = client.factory.create('folder')
                folder.name = "OpenERP Partners"
                folder.syncable = True
                folder.readable = True
                folder.writable = True
                folder.manageable = True
                folder.synced = True
                folder.owner = access_token['userId']
                folderResp = client.service.createFolder(access_token,folder)
                folder_id = folderResp.id  
                client.service.subscribreMassUserFromAFolder(access_token, folder_id, [access_token['userId']])      
        except WebFault, f:
            print f
            _logger.debug(f)
            _logger.debug(f.fault)
        except Exception, e:
            print e
            _logger.debug(e)
        return folder_id 
    
    def _create_last_sync(self, cr, uid):
        calendar_config = self.pool.get('calendar.config')
        calendar_config_ids = calendar_config.search(cr, uid,[])
        if calendar_config_ids:
            calendar_config.unlink(cr, uid, calendar_config_ids)
            calendar_config.create(cr, uid, {'event_last_sync': datetime.now().strftime('%Y-%m-%d %H:%M:%S')})
        else:
            calendar_config.create(cr, uid, {'event_last_sync': datetime.now().strftime('%Y-%m-%d %H:%M:%S')})
        return True
            
bluemind_connection()

class bluemind_users(osv.osv):
    _name = 'bluemind.users'
    _sql_constraints = [
        ('name_uniq', 'unique(name)', 'User name must be unique!'),
    ]
    _columns = {
                'name': fields.char('Bluemind user', size=255, required=True),
#                'password': fields.char('Bluemind password', size=255, required=True),
#                'api_key': fields.char('Api key', size=255, required=True)
            } 
    def create(self, cr, uid, vals, context=None):
        if 'name' in vals and vals['name']:
            if '@' not in vals['name']:
                vals['name'] = self._check_user_name(cr, uid, vals['name'])
        res = super(bluemind_users, self).create(cr, uid, vals, context)
        return res
    
    def write(self, cr, uid, ids, vals, context=None):
        if 'name' in vals and vals['name']:
            if '@' not in vals['name']:
                vals['name'] = self._check_user_name(cr, uid, vals['name'])
        res = super(bluemind_users, self).create(cr, uid, vals, context)
        return res
    
    def _check_user_name(self, cr, uid, user_name):
        blmind_config = self.pool.get('bluemind.config')
        config_data_ids = blmind_config.search(cr, uid,[])
        domain = blmind_config.read(cr, uid, config_data_ids,['domain'])[0]['domain']
        user_name = user_name+'@'+domain
        return user_name
bluemind_users()

class res_users(osv.osv):
    _inherit='res.users'
    _columns = {
            'bluemind_user_id':fields.many2one('bluemind.users','Bluemind user'),
               }
res_users()

 