# -*- coding: utf-8 -*-
##############################################################################
# SUDOKEYS:2014
# sudokeys_bluemind_connector
# Author:YL
# created:01-2014
#
#
#
#
##############################################################################

from tools.translate import _
from osv import osv, fields
from suds.client import Client
from suds import WebFault
import threading
from datetime import datetime,timedelta
import openerp.exceptions
from openerp import pooler, sql_db
import logging
_logger = logging.getLogger(__name__)     
logging.basicConfig(level=logging.INFO)
if __debug__:
    logging.getLogger('suds.client').setLevel(logging.DEBUG)
else:
    logging.getLogger('suds.client').setLevel(logging.CRITICAL)
class res_partner_category(osv.osv):
    _inherit = 'res.partner.category'
    _columns = {
            'blmind_id': fields.integer(u'Bluemind tag ID'),
            }
    
res_partner_category()    

class bluemind_contact(osv.osv):
    _name = 'bluemind.contact' 
    _columns = {
            'name':fields.integer('Bluemind contact ID', required =True),
            'openerp_partner_id':fields.integer('OpenERP partner ID', required=True),
            }   
    def _get_contact_accessToken(self, cr, uid, config_data):
        user_access_token = False
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        client = blmind_config.get_client(cr, uid, config_data)
        admin_accessToken = blmind_config.get_accessToken(cr, uid, config_data)
        user_access_token = client.service.sudo(admin_accessToken, config_data['domain_admin'])
        return user_access_token
    
    def _prepare_write_vals(self, cr, uid, client, oerp_vals, contact):
        partner = self.pool.get('res.partner')
        if 'name' in oerp_vals and oerp_vals['name']:
            contact.lastname = oerp_vals['name']
        if 'category_id' in oerp_vals: 
            category_id = oerp_vals['category_id']
            if category_id and category_id[0] and category_id[0][2]:
                contact.tags = []
                category_ids = category_id[0][2]
                for etiqu_name in self.pool.get('res.partner.category').read(cr, uid, category_ids,['name']):
                    contact.tags.append({'label':etiqu_name['name']})
        address = {}
        if hasattr(contact,'addresses') and contact.addresses:
            for addr in contact.addresses.entry:
                if "WORK" in addr.key:
                    address = dict(addr.value)
        if 'street' in oerp_vals and oerp_vals['street']:
            address['street'] = oerp_vals['street']
        if 'city' in oerp_vals and oerp_vals['city']:
            address['town'] = oerp_vals['city']
        if 'zip' in oerp_vals and oerp_vals['zip']:
            address['zipCode'] = oerp_vals['zip']   
        if 'country_id' in oerp_vals and oerp_vals['country_id']:
            address['country'] = self.pool.get('res.country').browse(cr, uid, [oerp_vals['country_id']])[0].name       
        if 'state_id' in oerp_vals and oerp_vals['state_id']:
            address['state'] = self.pool.get('res.country.state').browse(cr, uid, [oerp_vals['state_id']])[0].name 
        if address:
            contact.addresses = {'entry': [{'key':'WORK', 'value':address}]}    
        if 'email' in oerp_vals and oerp_vals['email']:
            email = {'allAliases':True,'default':True,'email':oerp_vals['email']}
            contact.emails.entry=[{'key':'email','value':email}] 
        phones = dict(contact.phones)
        new_phone_entry = []
        if not phones:
            if 'phone' in oerp_vals:
                if oerp_vals['phone']: 
                        new_phone_entry.append({'key':"WORK;VOICE",'value':{'number':oerp_vals['phone']}})
            if 'mobile' in oerp_vals:
                if oerp_vals['mobile']: 
                        new_phone_entry.append({'key':"CELL;VOICE",'value':{'number':oerp_vals['mobile']}})
            if 'mobile' in oerp_vals:
                if oerp_vals['fax']: 
                        new_phone_entry.append({'key':"WORK;FAX",'value':{'number':oerp_vals['fax']}})
            contact.phones={'entry':new_phone_entry}
        else:
            if 'phone' in oerp_vals:
                if oerp_vals['phone']: 
                    phone_exist = False
                    for phone in phones['entry']:
                        if phone["key"]=="WORK;VOICE" :
                            phone["value"] = {'number':oerp_vals['phone']}
                            phone_exist = True
                    if not phone_exist:
                        phones['entry'].append({'key':"WORK;VOICE",'value':{'number':oerp_vals['phone']}})
                            
                else:
                    for phone in phones['entry']:
                        if phone["key"]=="WORK;VOICE" :
                            phones['entry'].remove(phone)
            if 'mobile' in oerp_vals:
                if oerp_vals['mobile']: 
                    mobile_exist = False
                    for phone in phones['entry']:
                        if phone["key"]=="CELL;VOICE" :
                            phone["value"] = {'number':oerp_vals['mobile']}
                            mobile_exist = True
                    if not mobile_exist:
                        phones['entry'].append({'key':"CELL;VOICE",'value':{'number':oerp_vals['mobile']}})
                else:
                    for phone in phones['entry']:
                        if phone["key"]=="CELL;VOICE" :
                            phones['entry'].remove(phone)
            if 'fax' in oerp_vals:
                if oerp_vals['fax']: 
                    fax_exist = False
                    for phone in phones['entry']:
                        if phone["key"]=="WORK;FAX" :
                            phone["value"] = {'number':oerp_vals['fax']}
                            fax_exist = True
                    if not fax_exist:
                        phones['entry'].append({'key':"WORK;FAX",'value':{'number':oerp_vals['fax']}})
                else:
                    for phone in phones['entry']:
                        if phone["key"]=="WORK;FAX" :
                            phones['entry'].remove(phone)
            contact.phones = phones                  
        if 'is_company' in oerp_vals:
            if oerp_vals['is_company']:
                contact.company = (('name' in oerp_vals) and oerp_vals['name']) or contact.lastname
            else:
                if 'parent_id' in oerp_vals and oerp_vals['parent_id']:
                    contact.company = partner.read(cr, uid, [oerp_vals['parent_id']], ['name'])[0]['name']
        if 'parent_id' in oerp_vals:
            is_company = partner.read(cr, uid, [int(contact.externalId)],['is_company'])[0]['is_company']
            if oerp_vals['parent_id']:
                if is_company:
                    contact.company = contact.lastname
                else:
                    contact.company = partner.read(cr, uid, [oerp_vals['parent_id']], ['name'])[0]['name']
            else:
                if is_company:
                    contact.company = contact.lastname
                else:
                    contact.company = None
        if 'title' in oerp_vals:
            if oerp_vals['title']:
                contact.title = self.pool.get('res.partner.title').read(cr, uid, [oerp_vals['title']],['name'])[0]['name']
            else:
                contact.title = None
        if 'function' in oerp_vals:
            if oerp_vals['function']:
                contact.service = oerp_vals['function']
            else:
                contact.service = None
        websites = dict(contact.websites) 
        if 'website' in oerp_vals :
            if not websites:
                if oerp_vals['website']:
                    contact.websites = {'entry':[{'key':'WORK','value':{'url':oerp_vals['website']}}]}
            else:
                if oerp_vals['website']:
                    website_exist = False
                    for website in websites['entry']:
                        if website['key']=='WORK':
                            website['value'] = {'url':oerp_vals['website']}
                            website_exist = True
                    if not website_exist:
                        contact.websites.entry.append({'key':'WORK','value':{'url':oerp_vals['website']}})
                else:
                    for website in websites['entry']:
                        if website['key']=='WORK':
                            contact.websites.entry.remove(website)                    
        if 'comment' in oerp_vals:
            if oerp_vals['comment']:
                contact.description = oerp_vals['comment']
            else:
                contact.description = None
        return contact  
    
    def _prepare_create_vals(self, cr, uid, client, oerp_vals, contact):
        partner_categ = self.pool.get('res.partner.category')
        partner = self.pool.get('res.partner')
        if 'id' in oerp_vals:
            contact.externalId = oerp_vals['id']
        contact.lastname = oerp_vals['name']
        category_id = oerp_vals['category_id']
        #~ if category_id and category_id[0] and category_id[0][2]:
        if category_id:
            category_ids = category_id
            for etiqu_name in self.pool.get('res.partner.category').read(cr, uid, category_ids,['name']):
                contact.tags.append({'label':etiqu_name['name']})
        address = {}
        if 'street' in oerp_vals and oerp_vals['street']:
            address['street'] = oerp_vals['street']
        if 'city' in oerp_vals and oerp_vals['city']:
            address['town'] = oerp_vals['city']
        if 'zip' in oerp_vals and oerp_vals['zip']:
            address['zipCode'] = oerp_vals['zip']   
        if 'country_id' in oerp_vals and oerp_vals['country_id']:
            address['country'] = self.pool.get('res.country').browse(cr, uid, oerp_vals['country_id']).name       
        if 'state_id' in oerp_vals and oerp_vals['state_id']:
            address['state'] = self.pool.get('res.country.state').browse(cr, uid, oerp_vals['state_id']).name 
        if address:
            contact.addresses.entry = [{'key':'WORK', 'value':address}]        
        contact.emails.entry=[{'key':'email','value':{'allAliases':True,'default':True,'email':oerp_vals['email']}}]                 
        phones = []
        if oerp_vals['phone']:
            phones.append({'key':"WORK;VOICE",'value':{'number':oerp_vals['phone']}})
        if oerp_vals['mobile']:
            phones.append({'key':"CELL;VOICE",'value':{'number':oerp_vals['mobile']}})
        if 'fax' in oerp_vals and oerp_vals['fax']:
            phones.append({'key':"WORK;FAX",'value':{'number':oerp_vals['fax']}})
        contact.phones.entry = phones
        if 'is_company' in oerp_vals and oerp_vals['is_company']:
            contact.company = oerp_vals['name']
        else:
            if oerp_vals['parent_id']:
                parent_names = partner.read(cr, uid, [oerp_vals['parent_id']], ['name'])
                contact.company = parent_names and parent_names[0]['name'] or None
        if 'title' in oerp_vals and oerp_vals['title']:
            contact.title = self.pool.get('res.partner.title').read(cr, uid, [oerp_vals['title']],['name'])[0]['name']
        if 'website' in oerp_vals and oerp_vals['website']:
            contact.websites = {'entry':[{'key':'WORK','value':{'url':oerp_vals['website']}}]}
        if 'comment' in oerp_vals and oerp_vals['comment']:
            contact.description = oerp_vals['comment']
        return contact    
       
    def create_contact(self, dbname, uid, vals):
        db = sql_db.db_connect(dbname)
        cr = db.cursor()
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        folder_id = config_data['folder_id']
        client = blmind_config.get_client(cr, uid, config_data)
        accessToken = self._get_contact_accessToken(cr, uid, config_data)
        try:
            contact = client.factory.create('contact')
            contact = self._prepare_create_vals(cr, uid, client, vals, contact)
            contact.folderId = folder_id
            contact_resp = client.service.createContact(accessToken, contact)
            if contact_resp.id:   
                time_changed = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
                if hasattr(contact_resp,'timeCreate'):
                    time_changed = contact_resp.timeCreate.strftime('%Y-%m-%d %H:%M:%S')
                self.create(cr, uid, {'name':contact_resp.id, 'openerp_partner_id':contact_resp.externalId,'time_changed': time_changed})
            cr.commit()
            cr.close()
            client.service.logout(accessToken)
        except WebFault, e:
            cr.close()
            client.service.logout(accessToken)
            print e
            _logger.debug(e)
        return True
    
    def update_contacts_from_bluemind(self, cr, uid):
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        client = blmind_config.get_client(cr, uid, config_data)
        accessToken = self._get_contact_accessToken(cr, uid, config_data)
        try:
            clientContactChanges = client.factory.create('clientContactChanges')
            clientChange = client.factory.create('clientChange')
            clientContactChanges.updated = [clientChange]
            clientContactChanges.removed = [clientChange]
            syncScope = client.factory.create('syncScope')
            syncScope.onlyMyContacts = False
            datetime_value = datetime.strptime(config_data['contact_last_sync'],'%Y-%m-%d %H:%M:%S')-timedelta(seconds=1)
            contactChanges = client.service.doContactSync(accessToken, clientContactChanges, syncScope, datetime_value)
            if hasattr(contactChanges, 'removed'):    
                blmind_ids2delete = [ elm.id for elm in contactChanges.removed]
                self.delete_oerp_contacts(cr, uid, blmind_ids2delete)
            if hasattr(contactChanges, 'updated'):
                contacts = [contact for contact in contactChanges.updated if contact.folderId==config_data['folder_id']]
                self.update_oerp_contacts(cr, uid, contacts)
            blmind_config_ids = blmind_config.search(cr, uid, [])
            cr.execute("update bluemind_config set contact_last_sync='%s'"%(contactChanges.lastSync.strftime('%Y-%m-%d %H:%M:%S'),))
#            blmind_config.write(cr, uid, blmind_config_ids, {'contact_last_sync':contactChanges.lastSync.strftime('%Y-%m-%d %H:%M:%S')})
            client.service.logout(accessToken)
        except WebFault, f:
            print f
            client.service.logout(accessToken)
            _logger.debug(f)
        return True

    def update_oerp_contacts(self, cr, uid, contacts):
        partner = self.pool.get('res.partner')
        for contact in contacts:
            if contact.displayName:
                vals = {}
                vals['name'] = contact.displayName
#                if contact.company:
#                    vals['parent_id'] = partner.create(cr, uid,{'name':contact.company,'is_company':True})
#                else:
#                    vals['parent_id'] = False
                if hasattr(contact,'tags'):
                    blmind_tags = []
                    new_contact_tags = []
                    if contact.tags:
                        blmind_tags = [tag.label for tag in contact.tags]
                    if blmind_tags:
                        for blmind_tag in blmind_tags:
                            partner_categ_ids = self.pool.get('res.partner.category').search(cr, uid, [('name','=',blmind_tag)])
                            if partner_categ_ids:
                                new_contact_tags.extend(partner_categ_ids)
                            else:
                                partner_categ_id = self.pool.get('res.partner.category').create(cr, uid,{'name':blmind_tag})
                                if partner_categ_id:
                                    new_contact_tags.append(partner_categ_id)
                        if new_contact_tags:        
                            vals['category_id'] = [[6,False,new_contact_tags]]
                vals['function'] = contact.service
                if contact.phones:
                    phones = contact.phones.entry
                    for ph in phones:
                        if 'WORK;VOICE' in ph.key:
                            vals['phone'] = ph.value.number
                        if 'CELL;VOICE' in ph.key:
                            vals['mobile'] = ph.value.number
                        if 'WORK;FAX' in ph.key:
                            vals['fax'] = ph.value.number
                if contact.addresses:
                    addresses = contact.addresses.entry
                    adr_work = False
                    for adr in addresses:
                        if 'WORK' in adr.key:
                            adr_work = adr.value
                    if not adr_work:
                        for adr in addresses:
                           adr_work = adr.value                         
                    if adr_work:
                        vals['street'] = adr_work.street
                        vals['city'] = adr_work.town
                        vals['zip'] = adr_work.zipCode 
                        if adr_work.country:
                            country = adr_work.country
                            country_ids = self.pool.get('res.country').search(cr, uid, [('name','in',[country,country.lower()])]) 
                            if country_ids:
                                vals['country_id'] =  country_ids[0]
                        if adr_work.state:
                            state = adr_work.state
                            state_ids = self.pool.get('res.country.state').search(cr, uid, [('name','in',[state,state.lower()])]) 
                            if state_ids:
                                vals['state_id'] =  state_ids[0]
                if contact.emails:
                    emails = contact.emails.entry
                    vals['email'] = False
                    for email in emails:
                        if email.value.default:
                            vals['email'] = email.value.email
                if contact.title:
                    tle = contact.title
                    title_ids = self.pool.get('res.partner.title').search(cr, uid,[])
                    titles = self.pool.get('res.partner.title').read(cr, uid, title_ids,['name','shortcut'])
                    for title in titles:
                        if tle in title['name'] or tle in title['shortcut']:
                            vals['title'] = title['id']
                if contact.websites:
                    websites = contact.websites.entry
                    vals['website'] = False
                    for website in websites:
                        if 'WORK' in website.key:
                            vals['website'] = website.value.url
                    if not vals['website']:
                        vals['website'] = websites[0].value.url
                if contact.description:
                    vals['comment'] = contact.description
                blmind_contact_ids = self.search(cr, uid, [('name','=',contact.id)])
                if blmind_contact_ids:
                    openerp_partner_id = self.read(cr, uid, blmind_contact_ids, ['openerp_partner_id'])[0]['openerp_partner_id']       
                    openerp_partner_ids = partner.search(cr, uid, [('id','=',openerp_partner_id)])
                    if openerp_partner_ids:
                        res_write = partner.write(cr, uid, openerp_partner_ids, vals, context={'from_blmind':True})
                        if res_write:
                            self.write(cr, uid, blmind_contact_ids, {'time_changed':datetime.now().strftime('%Y-%m-%d %H:%M:%S')}) 
                else:
                    vals['is_company'] = False
                    openerp_partner_id = partner.create(cr, uid, vals, context={'from_blmind':True}) 
                    if openerp_partner_id:
                        self.create(cr, uid, {'openerp_partner_id':openerp_partner_id,'name':contact.id,'time_changed':datetime.now().strftime('%Y-%m-%d %H:%M:%S')})      
                         
        return True
      
    def delete_oerp_contacts(self, cr, uid, blmind_ids):
        bluemind_contact_ids = self.search(cr, uid, [('name','in',blmind_ids)])
        blmind_deleted_contacts_ids = [data['openerp_partner_id'] for data in self.read(cr, uid,bluemind_contact_ids)]
        deleted = self.pool.get('res.partner').unlink(cr, uid, blmind_deleted_contacts_ids, context={'from_blmind':True})
        if deleted:
            self.unlink(cr, uid, bluemind_contact_ids)
        return True
        
    def update_contact(self, dbname, uid, vals, contact_id):
        db = sql_db.db_connect(dbname)
        cr = db.cursor()
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        client = blmind_config.get_client(cr, uid, config_data)
        accessToken = self._get_contact_accessToken(cr, uid, config_data)
        try:
            contact = client.service.getContactFromId(accessToken, contact_id)
            contact = self._prepare_write_vals(cr, uid, client, vals, contact)
            contact = client.service.updateContact(accessToken, contact)
            cr.commit()
            cr.close()
            client.service.logout(accessToken)
        except WebFault, e:
            cr.close()
            client.service.logout(accessToken)
            print e
            _logger.debug(e)
        return contact
    
    def delete_contact(self, dbname, uid, contact_id):
        db = sql_db.db_connect(dbname)
        cr = db.cursor()
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        client = blmind_config.get_client(cr, uid, config_data)
        accessToken = self._get_contact_accessToken(cr, uid, config_data)
        try:
            contact = client.service.deleteContact(accessToken, contact_id)
            if contact.externalId:
                blmind_contcat_ids = self.search(cr, uid, [('openerp_partner_id','=',int(contact.externalId))])
                self.unlink(cr, uid,blmind_contcat_ids)
            cr.commit()
            cr.close()
            client.service.logout(accessToken)
        except WebFault, e:
            cr.close()
            client.service.logout(accessToken)
            print e
            _logger.debug(e)
        return contact
bluemind_contact()    

class res_partner(osv.osv):
    _inherit = 'res.partner'
    
    def _get_in_bluemind(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        blmind_contact = self.pool.get('bluemind.contact')
        for o in self.browse(cr, uid, ids, context):
            blmind_contact_ids = blmind_contact.search(cr, uid, [('openerp_partner_id','=',o.id)])
            if blmind_contact_ids:
                res[o.id] = True
            else:
                res[o.id]=False
        return res
    def _get_blmind_partner_id(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        blmind_contact = self.pool.get('bluemind.contact')
        for o in self.browse(cr, uid, ids, context):
            blmind_contact_ids = blmind_contact.search(cr, uid, [('openerp_partner_id','=',o.id)])
            if blmind_contact_ids:
                res[o.id] = blmind_contact.read(cr, uid, blmind_contact_ids,['name'])[0]['name']

            else:
                res[o.id] = 0
        return res
    _columns = {
            'in_bluemind':fields.function(_get_in_bluemind, type='boolean', string='Is in Bluemind ?'),
            'blmind_partner_id':fields.function(_get_blmind_partner_id, type='integer', string='Bluemind contact ID'),
            }
    def _can_auto_update_bluemind(self, cr, uid, context=None):
        can_update = False
        can_update = self.pool.get('res.users').read(cr, uid, [uid], ['auto_bluemind_partner'], context)[0]['auto_bluemind_partner']
        return can_update
    
    def create(self, cr, uid, vals, context=None):
        if not context:
            context = {}
        res = super(res_partner, self).create(cr, uid, vals, context)
        if self._can_auto_update_bluemind(cr, uid, context=context) and vals.get('email',False) and not context.get('from_blmind',False):
            if res:
                vals['id'] = str(res)
            create_contact = self.pool.get('bluemind.contact').create_contact
            dbname = cr.dbname
            thr = threading.Thread(target=create_contact, args=(dbname,uid,vals))
            thr.start()
        return res
    
    def write(self, cr, uid, ids, vals, context=None):
        if not context:
            context = {}
        if isinstance(ids, int):
            ids=[ids]
        if self._can_auto_update_bluemind(cr, uid, context=context) and not context.get('from_blmind',False):
            blmind_contact = self.pool.get('bluemind.contact')
            blmind_contact_ids = blmind_contact.search(cr,uid, [('openerp_partner_id','in',ids)])
            for blmind_contact_data in blmind_contact.read(cr, uid, blmind_contact_ids, ['name'], context=context):
                update_contact = self.pool.get('bluemind.contact').update_contact
                dbname = cr.dbname
                thr = threading.Thread(target=update_contact, args=(dbname,uid,vals,blmind_contact_data['name']))
                thr.start()               
        return super(res_partner, self).write(cr, uid, ids, vals, context=context)
    
    def unlink(self, cr, uid, ids, context=None):
        if not context:
            context = {}
        if isinstance(ids, int):
            ids=[ids]
        if self._can_auto_update_bluemind(cr, uid, context=context) and not context.get('from_blmind',False):
            blmind_contact = self.pool.get('bluemind.contact')
            blmind_contact_ids = blmind_contact.search(cr,uid, [('openerp_partner_id','in',ids)])
            for blmind_contact_data in blmind_contact.read(cr, uid, blmind_contact_ids, ['name'], context=context):
                delete_contact = self.pool.get('bluemind.contact').delete_contact
                dbname = cr.dbname
                thr = threading.Thread(target=delete_contact, args=(dbname,uid,blmind_contact_data['name']))
                thr.start()
        return super(res_partner, self).unlink(cr, uid, ids, context=context)
res_partner()  

class res_users(osv.osv):
    _inherit='res.users'
    _columns = {
            'auto_bluemind_partner':fields.boolean(u'Update a Bluemind contact at every OpenERP contact update'),
            }
    def push_partners(self, cr, uid, ids, context=None):
        if isinstance(ids,int):
            ids = [ids]
        res_partner = self.pool.get('res.partner')
        partners_ids = self.pool.get('res.partner').search(cr, uid, [('active','=',True),('email','!=',False)])
        partn_datas = res_partner.read(cr, uid,partners_ids,[],context=context)
        blmind_contact = self.pool.get('bluemind.contact')
        for part_dt in partn_datas:
            if not part_dt['in_bluemind'] :
                if part_dt['parent_id']:
                    part_dt['parent_id'] = part_dt['parent_id'][0] or False
                if part_dt['title']:
                    part_dt['title'] = part_dt['title'][0] or False
                contact = blmind_contact.create_contact(cr.dbname, uid, part_dt)
        return True
res_users()
