# -*- coding: utf-8 -*-
##############################################################################
# SUDOKEYS:2014
# sudokeys_bluemind_connector
# Author:YL
# created:01-2014
#
#
#
#
##############################################################################

from tools.translate import _
from osv import osv, fields
from suds.client import Client
from suds import WebFault
import threading
from openerp import pooler, sql_db
from datetime import datetime
import logging
    
logging.basicConfig(level=logging.INFO)
if __debug__:
    logging.getLogger('suds.client').setLevel(logging.DEBUG)
else:
    logging.getLogger('suds.client').setLevel(logging.CRITICAL)

class push_events(osv.osv_memory):
    _name = 'push.events'
    _columns = {
            'calendar_type_ids':fields.many2many('calendar.type','push_cal_type_rel','push_id','cal_id','Push all events'),
            }
    def push_events_to_bluemind(self, cr, uid, ids, context=None):
        cal_types = self.browse(cr, uid, ids)[0].calendar_type_ids
        res_user = self.pool.get('res.users').browse(cr, uid, [uid])[0]
        blmind_user = res_user.bluemind_user_id or False
        if cal_types and blmind_user:
            for cal_type in cal_types:
                blmind_cal_ids = self.pool.get('bluemind.calendar').search(cr, uid,[('calendar_type_id','=',cal_type.id)])
                oerp_event_exist_ids = []
                if blmind_cal_ids:
                    oerp_event_exist_ids = [oerp_event['oerp_event_id'] for oerp_event in self.pool.get('bluemind.calendar').read(cr, uid,blmind_cal_ids,['oerp_event_id'])]
                domain= []
                if oerp_event_exist_ids:
                    domain.append(('id','not in',oerp_event_exist_ids))
                event_to_create_ids = self.pool.get(cal_type.model).search(cr, uid, domain)
                vals_list = self.pool.get(cal_type.model).read(cr, uid,event_to_create_ids)
                if cal_type.model=="crm.meeting":
                    domain.append(('user_id','=',uid))
                    if oerp_event_exist_ids:
                        domain.append(('id','not in',oerp_event_exist_ids))
                    event_to_create_ids = self.pool.get(cal_type.model).search(cr, uid, domain)
                    vals_list = self.pool.get(cal_type.model).read(cr, uid,event_to_create_ids)
                    for vals in vals_list:
                        attendee_ids = vals['attendee_ids']
                        if attendee_ids:
                            vals['attendee_ids'] = [[0,False, {'partner_id':attendee['partner_id'] and attendee['partner_id'][0],'email':attendee['email']}]for attendee in self.pool.get('calendar.attendee').read(cr, uid, attendee_ids, ['partner_id','email'])]                       
                        self.create_all_events(cr,uid,vals,cal_type,blmind_user)    
                if cal_type.model=="project.task":
                    domain = [('user_id','=',uid)]
                    if oerp_event_exist_ids:
                        domain.append(('id','not in',oerp_event_exist_ids))
                    event_to_create_ids = self.pool.get(cal_type.model).search(cr, uid, domain)
                    vals_list = self.pool.get(cal_type.model).read(cr, uid,event_to_create_ids)
                    for vals in vals_list:                       
                        if vals['date_deadline']:
                            if vals['partner_id']:
                                vals['partner_id'] = vals['partner_id'][0]
                            self.create_all_events(cr,uid,vals,cal_type,blmind_user)  
                if cal_type.model=="hr.holidays":
                    employee_id = self.pool.get('hr.employee').search(cr, uid, [('user_id','=',uid)])
                    domain = []
                    if employee_id:
                        domain.append(('employee_id','in',employee_id))
                    if oerp_event_exist_ids:
                        domain.append(('id','not in',oerp_event_exist_ids))
                    event_to_create_ids = self.pool.get(cal_type.model).search(cr, uid, domain)
                    vals_list = self.pool.get(cal_type.model).read(cr, uid,event_to_create_ids)
                    for vals in vals_list:
                        if vals['date_from'] and vals['date_to']:                      
                            if vals['holiday_status_id']:
                                vals['holiday_status_id'] = vals['holiday_status_id'][0]
                            self.create_all_events(cr,uid,vals,cal_type,blmind_user) 
        return True 
    
    def create_all_events(self, cr, uid, vals, cal_type, blmind_user):
        blmind_config = self.pool.get('bluemind.config')
        config_data = blmind_config.get_config_data(cr, uid)
        client = blmind_config.get_client(cr, uid, config_data)
        blmin_cal = self.pool.get('bluemind.calendar')
        accessToken = blmin_cal._get_cal_accessToken(cr, uid, blmind_user, config_data)
        event_id = False
        try:
            event = client.factory.create('event')
            event = blmin_cal._prepare_create_event(cr, uid, client, accessToken, vals, event, cal_type, blmind_user)
            event_id = client.service.createEvent(accessToken, event)
            if event_id:
                event = client.service.getEventFromId(accessToken, event_id)
                if event:
                    blmin_cal.create(cr, uid, {'calendar_type_id':cal_type.id, 'blmind_event_id':event_id,'oerp_event_id':event.extId,'blmind_user_id':blmind_user.id})
            client.service.logout(accessToken)
            cr.commit()
        except WebFault, e:
            client.service.logout(accessToken)
            print e
            _logger.debug(e)
        return event_id    
    
push_events()    